Subject: [IPP] Proposed text for a Register-Output-Device operation

From: Michael Sweet <[email-masked]>
Date: Mon, 15 May 2017 17:29:27 -0400

All,

Here is my proposed text for a Register-Output-Device operation...

6.4.7 Register-Output-Device

This CONDITIONALLY REQUIRED operation allows a Proxy to register an Output Device with the target System object.  Systems that conform to the IPP Shared Infrastructure Extensions (INFRA) MUST support this operation.

The Register-Output-Device operation returns a Printer object of the specified type that accepts Jobs on behalf of the Output Device.  How these Printer objects are created or provisioned is implementation-specific.

Access Rights: The authenticated user (see section 8.3 of [RFC2911]) performing this operation must be a Proxy of the Printer object. Otherwise, the Infrastructure Printer MUST reject the operation and return: 'client-error-forbidden', 'client-error-not-authenticated', or 'client-error-not-authorized' as appropriate.

6.4.7.1 Register-Output-Device Request

The following groups of attributes are part of a Register-Output-Device request.

Group 1: Operation Attributes

"attributes-charset" (charset) and "attributes-natural-language" (naturalLanguage):

The Client MUST supply and the System MUST support both of these attributes.

“system-uri” (uri):

The Client MUST supply and the System MUST support the “system-uri” operation attribute which is the target System for the operation.

"requesting-user-name" (name(MAX)) and "requesting-user-uri" (uri) and “requesting-user-vcard” (1setOf text(1023)): 

The Client SHOULD supply and the System MUST support all three of these attributes.

“printer-service-type” (type2 keyword):

The Client MUST supply and the System MUST support this attribute.

"output-device-uuid" (uri):

The Proxy MUST supply this attribute and the Infrastructure Printer MUST support this attribute.  It provides the identity of the Output Device for the request.

6.4.7.2 Register-Output-Device Response

The following groups of attributes are part of a Register-Output-Device response.

Group 1: Operation Attributes

"attributes-charset" (charset) and "attributes-natural-language" (naturalLanguage):

The System MUST return both of these attributes.

"status-message" (text(255)) and/or "detailed-status-message" (text(MAX)):

The System MAY return one or both of these attributes.

Group 2: Unsupported Attributes

See [RFC8011] for details on returning Unsupported Attributes.

Group 3: Printer Attributes

See [RFC8011] for details on returning Printer Attributes.

“printer-id (integer(1:MAX)):

The System MUST return this attribute.

“printer-uuid” (uri(45)):

The System MUST return this attribute.

“printer-xri-supported” (1setOf collection)

The System MUST return this attribute.

“printer-state” (type1 enum) and “printer-state-reasons” (1setOf type2 keyword) and “printer-is-accepting-jobs” (boolean):

The System MUST return all three of these attributes.

_________________________________________________________
Michael Sweet, Senior Printing System Engineer

_______________________________________________
ipp mailing list
[email-masked]
https://www.pwg.org/mailman/listinfo/ipp

---

From: Ira McDonald <[email-masked]>
Date: Mon, 15 May 2017 19:46:35 -0400

Hi Mike,

Thanks much.

I'll fix the cut-and-paste RFC 2911 reference when I add this to the System
Service spec.

I think I should also add an "Access Rights" paragraph to all of the
operations in the spec.

Cheers,
- Ira

Ira McDonald (Musician / Software Architect)
Co-Chair - TCG Trusted Mobility Solutions WG
Chair - Linux Foundation Open Printing WG
Secretary - IEEE-ISTO Printer Working Group
Co-Chair - IEEE-ISTO PWG Internet Printing Protocol WG
IETF Designated Expert - IPP & Printer MIB
Blue Roof Music / High North Inc
http://sites.google.com/site/blueroofmusic
http://sites.google.com/site/highnorthinc
mailto: [email-masked]
Jan-April: 579 Park Place  Saline, MI  48176  734-944-0094
May-Dec: PO Box 221  Grand Marais, MI 49839  906-494-2434

On Mon, May 15, 2017 at 5:29 PM, Michael Sweet <[email-masked]> wrote:

> This CONDITIONALLY REQUIRED operation allows a Proxy to register an Output
> Device with the target System object.  Systems that conform to the IPP
> Shared Infrastructure Extensions (INFRA) MUST support this operation.
>
> The Register-Output-Device operation returns a Printer object of the
> specified type that accepts Jobs on behalf of the Output Device.  How these
> Printer objects are created or provisioned is implementation-specific.
>
> Access Rights: The authenticated user (see section 8.3 of [RFC2911])
> performing this operation must be a Proxy of the Printer object. Otherwise,
> the Infrastructure Printer MUST reject the operation and return:
> 'client-error-forbidden', 'client-error-not-authenticated',
> or 'client-error-not-authorized' as appropriate.
>
>
> The Client MUST supply and the System MUST support the
> “system-uri” operation attribute which is the target System for the
> operation.
>
> "requesting-user-name" (name(MAX)) and "requesting-user-uri" (uri)
> and “requesting-user-vcard” (1setOf text(1023)):
>
> The Proxy MUST supply this attribute and the Infrastructure Printer
> MUST support this attribute.  It provides the identity of the Output Device
> for the request.
>
>
> “printer-state” (type1 enum) and “printer-state-reasons” (1setOf type2
> keyword) and “printer-is-accepting-jobs” (boolean):
>